unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  flag:boolean;
  x0,y0,lastX,lastY:integer;

implementation

{$R *.DFM}

procedure TForm1.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
if flag then
   with form1.canvas do
   begin
        pen.Style:=psDash;
        pen.color:=clBlue;
        Rectangle(X0, Y0, X  , Y );
        pen.mode:=pmnot;
        Rectangle(X0, Y0, lastX  , lastY );
        lastX:=x; lastY:=y;
   end;
end;

procedure TForm1.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
if ssleft in shift then
begin
x0:=x;
y0:=y;
lastX:=x;
lastY:=y;
flag:=true;
canvas.moveto(x0,y0);
canvas.lineto(lastX,lastY);
end;
end;

procedure TForm1.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
canvas.pen.mode:=pmcopy;
canvas.Rectangle(X0, Y0, lastX  , lastY );
flag:=false;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
flag:=false;
end;

end.
